$(document).ready(function () {
    // basic setup
    var server = 'https://dam-demo.brix.ch/anura/demo';
    var lang = $.anura.getState('', 'lang', 'en'); $('.lang').hide(); $('.lang.' + lang).show();
    var basket = $('#anura-basket').anuraBasket({server: server, send: true});

    // main view
    var gallery = $('#anura-gallery').anuraGallery({
        server: server,
        basket: basket,
        locale: lang,
        paginate: 'auto',
        send: false,
        recursive: true,
        sort: 'score_desc',
        download_directly: false,
        download_menu: true,
        stream: true,
        detail_view: 'anura',
        detail_settings: {
            toolbar: {
                available: true, visible: true,
                layout: ['title', 'counter', 'slideshow', 'share', 'download', 'theme', 'basket', 'sidebar', 'close']
            },
            sidebar: {
                available: true, visible: true,
                settings: {
                    show: ['general', 'infofields', 'share', 'downloads', 'links']
                }
            }
        }
    });

    // navigation
    var info_template = {name: 'infofield', autosubmit: true, collapsible: false, style: 'select'};
    var search = $('#anura-search').anuraSearch({
        server: server,
        locale: lang, facets: true,
        widgets: [
            {name: 'text'},
            {name: 'extensions', autosubmit: true},
            {name: 'assettype', autosubmit: true, style: 'select'},
            $.extend({}, info_template, {id: 102}), // brand
            $.extend({}, info_template, {id: 116, root_node: 10909}), // product
            $.extend({}, info_template, {id: 114}), // model year
            $.extend({}, info_template, {id: 128}), // perspective
            $.extend({}, info_template, {id: 108, style: 'radio'}), // copyright
            //{name: 'type', others: false, autosubmit: true},
            {name: 'submit', show: true}
        ],
        callback: function (server, search_query) { // what do do with the search result (tell the gallery to load the search)
            gallery.anuraGallery({server: server, search: {custom: search_query}, locale: lang});

        },
        initial_search: true
    });

    // language selector
    $('#lang-select a').on('click', function (e) {
        lang = $(this).data('lang');
        basket.anuraBasket({locale: lang}); // tell the components to change their locale (while keeping the other settings)
        search.anuraSearch({locale: lang, initial_search: true /*does gallery as well*/});
        $('.lang').hide(); $('.lang.' + lang).show();
        $.anura.pushState('', 'lang', lang);
    });

    // sort selector
    $('#sort-select a').on('click', function (e) {
        $('#sort-indicator').attr('class', $(this).find('.glyphicon').attr('class'));
        gallery.anuraGallery({sort: $(this).data('sort')});
    });

    // size selector
    $('#size-select a').on('click', function (e) {
        $('#sort-indicator').attr('class', $(this).find('.glyphicon').attr('class'));
        gallery.anuraGallery({size: $(this).data('size')});
    });

    // top button
    $('#top').on('click', function (e) {
        $('html, body').animate({ scrollTop: 250 }, 600);
    });
});

