/* © brix cross media AG, http://www.brix.ch - It is strictly forbidden to change, reuse or copy the source code of this document. */
;(function ( $, window, document, undefined ) {
    var pluginName = "anuraBasketAddAll",
        defaults = {
            mainView: null, // the main view component to get the assets from, e.g. $('#this').anuraGallery({...});
            basket: null, // the basket component to put the assets into, e.g. $('#this').anuraBasket({...});
            hide_empty: true, // hide the this container when there are no results in the main view
            limit: 0 // limits the number of assets that will be put in the basket
        };
    function Plugin( element, options ) {
        this.element = $(element);
        this.container = this.element;
        this.options = $.extend( {}, defaults, options );
        this.total = 0;
        this._defaults = defaults;
        this._name = pluginName;
        this.init();
    }
    Plugin.prototype = {
        init: function() {
            var _this = this;
            if (this.options.hide_empty) this.element.hide();
            var counter = this.element.find('.anura-counter, .counter').first();
            this.options.mainView.on('anura-loaded-first', function (e, options, total) {
                _this.total = total;
               if (counter.length > 0) counter.text((_this.options.limit > 0) ? (Math.min(total, _this.options.limit)) : total);
               if (_this.options.hide_empty) _this.element.toggle(total > 0);
            });
            this.element.on('click', function () {
                if (_this.element.hasClass('anura-loading')) return;
                // TODO maybe ask for confirmation?
                var pageCall = $.extend({}, _this.options.mainView.data('pageCall'));
                pageCall.params.paginate = 0;
                pageCall.params.page = 0;
                if (_this.options.limit > 0) pageCall.params.limit = _this.options.limit;
                _this.element.addClass('anura-loading').removeClass('anura-error').css('cursor', 'wait');
                $.anura.getJSON(_this, pageCall.url, pageCall.params, 'anuraBasketAddAll', function (data, response) {
                    var assetIds = data.map(function (asset) {return asset.id});
                    _this.options.basket.anuraBasket({add: assetIds});
                    _this.element.removeClass('anura-loading').css('cursor', 'pointer');
                }, function () {
                    _this.element.addClass('anura-error').removeClass('anura-loading').css('cursor', 'pointer');
                });
            });
        },
    };
    $.fn[pluginName] = function ( options ) {
        return this.each(function (i, item) { // iterate matches
            var instance = $.data(item, "plugin_" + pluginName);
            if (!instance) { // if it has no instance yet, create it
                $.data(item, "plugin_" + pluginName, new Plugin( item, options ));
            } else { // otherwise merge new options with existing ones, empty and re-init
                instance.options = $.extend( {}, instance.options, options );
                instance.init();
            }
        });
    };
})( jQuery, window, document );
